/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: xutil.c,v $
 *
 * HISTORY
 * $Log: xutil.c,v $
 * Revision 1.2  1994/06/11  00:02:27  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/04/22  16:12:38  davidm
 * Initial revision
 *
 */
/*
 * Miscellaneous utility functions.
 */

#include <stdarg.h>
#include "x_util.h"
#include "xk_debug.h"
#include "platform.h"
#include "event.h"

int traceutil = 0;


static void
wakeup(Event e, void *arg)
{
    Semaphore *s = (Semaphore*) arg;

    semSignal(s);
} /* wakeup */


void
Delay(int msec)
{
    Semaphore s;

    xTrace1(util, TR_FUNCTIONAL_TRACE, "Delay(%d msec)", msec);
    if (msec == 0) {
	scout_thread_yield();
    } else {
	semInit(&s, 0);
	evDetach(evSchedule(wakeup, &s , msec*1000));	/* 3rd arg is in us */
	semWait(&s);
    } /* if */
    xTrace0(util, TR_FUNCTIONAL_TRACE, "Delay: returning.");
} /* Delay */


void
Kabort(char *why)
{
    scout_abort("%s", why);
} /* Kabort */

			/*** end of xutil.c ***/
