/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: getchar.c,v $
 *
 * HISTORY
 * $Log: getchar.c,v $
 * Revision 1.3  1994/06/11  00:02:45  menze
 * Added copyright notice
 *
 * Revision 1.2  1994/05/27  22:37:33  druschel
 * getchar() polling loop now yields the CPU.
 *
 * Revision 1.1  1994/05/14  23:31:11  davidm
 * Initial revision
 *
 */
/*
 * Get character from console.
 */
#include <machine/prom.h>
#include "alpha_console.h"
#include "alpha_misc.h"
#include "alpha_prom.h"

/*
 * The definition in prom.h is incorrect:
 */
#undef PROM_GETC
#define PROM_GETC(P_UNIT) \
	DISPATCH(CONS_GETC, P_UNIT, 0, 0, 0, 0, 0)

int
getchar(void)
{
    PROM_Result res;

    do {
	scout_thread_yield();
	res.bits = PROM_GETC(console_unit);
    } while (res.u.status > 1);
    return res.u.retval;
} /* getchar */

			/*** end of getchar.c ***/
