/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout_fifo.h,v $
 *
 * HISTORY
 * $Log: scout_fifo.h,v $
 * Revision 1.2  1994/06/11  00:03:01  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/05  00:35:06  davidm
 * Initial revision
 *
 */
#ifndef scout_fifo_h
#define scout_fifo_h

/*
 * This module provides a FIFO queueing service for multiple producers
 * and a single consumer that operate concurrently.  Usually, "append"
 * and "remove" can be invoked concurrently without incurring any
 * synchronization overheads.  The only case where synchronization
 * overheads occur is when removing the last element in a queue.
 */

struct scout_fifo_link {
    struct scout_fifo_link *next;
};

typedef struct {
    struct scout_fifo_link *head;
    struct scout_fifo_link *tail;
} Scout_FIFO;

extern void	scout_fifo_init (Scout_FIFO *q);
extern void	scout_fifo_append (Scout_FIFO *q, void *element);
extern void	*scout_fifo_remove (Scout_FIFO *q);

#endif /* scout_fifo_h */
